#ifndef KLX_RELFUN_HPP
#define KLX_RELFUN_HPP

//============================================================================
// <<operator functions>> library
//
//	֐IuWFNgB
//	  for_each( ptr_list.begin(), ptr_list.end(), deleter() );
//	Ń|C^Xgdelete肷̂ƁA
//	  sort( v.begin(), v.end(), kless() );
//	ŕёւs肷̂łBstd::less<int>() ̂悤
//	^̖OsvȂ̂B̑Astd::not2 Ƃ
//	nȂȂƌ_B
//
// [def]
//
//	deleter       : () -> 1ary-funcobj
//	deleter_array : () -> 1ary-funcobj
//
//	kequal_to      : () -> 2ary-funcobj
//	knot_equal_to  : () -> 2ary-funcobj
//	kless          : () -> 2ary-funcobj
//	kless_equal    : () -> 2ary-funcobj
//	kgreater       : () -> 2ary-funcobj
//	kgreater_equal : () -> 2ary-funcobj
//	klogical_and   : () -> 2ary-funcobj
//	klogical_or    : () -> 2ary-funcobj
//	klogical_not   : () -> 1ary-funcobj
//
//============================================================================

namespace klx {

// ^𖾎w肹ɍ쐬or֐IuWFNg

#define KLX_DEFINE_RELFUN_1( NAME, OP ) \
	struct KLX_PP_CAT(k,NAME)           \
	{                                   \
	  typedef bool result_type;         \
	  template<typename A>              \
	  bool operator()(const A& a) const \
	  {                                 \
	    return OP a;                    \
	  }                                 \
	}
#define KLX_DEFINE_RELFUN_2( NAME, OP )             \
	struct KLX_PP_CAT(k,NAME)                       \
	{                                               \
	  typedef bool result_type;                     \
	  template<typename A, typename B>              \
	  bool operator()(const A& a, const B& b) const \
	  {                                             \
	    return a OP b;                              \
	  }                                             \
	}

KLX_DEFINE_RELFUN_2( equal_to,      == );
KLX_DEFINE_RELFUN_2( not_equal_to,  != );
KLX_DEFINE_RELFUN_2( less,          <  );
KLX_DEFINE_RELFUN_2( less_equal,    <= );
KLX_DEFINE_RELFUN_2( greater,       >  );
KLX_DEFINE_RELFUN_2( greater_equal, >= );
KLX_DEFINE_RELFUN_2( logical_and  , && );
KLX_DEFINE_RELFUN_2( logical_or   , || );
KLX_DEFINE_RELFUN_1( logical_not  , !  );

#undef KLX_DEFINE_RELFUN_2
#undef KLX_DEFINE_RELFUN_1

// |C^delete֐IuWFNg

struct deleter
{
	typedef void result_type;
	template<typename T>
	void operator()( T* p ) const
	{
		delete p;
	}
};

// |C^ɔzdelete֐IuWFNg

struct deleter_array
{
	typedef void result_type;
	template<typename T>
	void operator()( T* p ) const
	{
		delete [] p;
	}
};



}      // namespace end
#endif // INCLUDE_GUARD
